# Cashfree Flutter SDK Sample

![GitHub](https://img.shields.io/github/license/cashfree/flutter-cashfree-pg-sdk) ![Discord](https://img.shields.io/discord/931125665669972018?label=discord) ![GitHub last commit (branch)](https://img.shields.io/github/last-commit/cashfree/flutter-cashfree-pg-sdk/main) ![GitHub release (with filter)](https://img.shields.io/github/v/release/cashfree/flutter-cashfree-pg-sdk?label=latest) ![Maven Central](https://img.shields.io/maven-central/v/com.cashfree.pg/api) ![GitHub forks](https://img.shields.io/github/forks/cashfree/flutter-cashfree-pg-sdk) [![Build](https://github.com/cashfree/flutter-cashfree-pg-sdk/actions/workflows/main.yml/badge.svg?branch=main)](https://github.com/cashfree/flutter-cashfree-pg-sdk/actions/workflows/main.yml) ![GitHub Repo stars](https://img.shields.io/github/stars/cashfree/flutter-cashfree-pg-sdk)


![Sample Banner Image](https://maven.cashfree.com/images/github-header-image-flutter.png)

## **Description** 

Sample integration project for Cashfree Payment Gateway's Flutter SDK, facilitating seamless and secure payment processing within your Flutter application.


## Documentation

The Cashfree Flutter SDK allows you to integrate Cashfree Payment Gateway into your application and start collecting payments from your customers. It has been designed to minimise the complexity of handling and integrating payments in your Flutter project.

### Getting Started

Please replace the values for orderId, token (Payment Session ID) and environment values in the example flutter project inside the repo and run.

```dart

  String orderId =  "ORDER_ID"; // replace with actual value
  String paymentSessionId =  "PAYMENT_SESSION_ID" // replace with actual value
  CFEnvironment environment = CFEnvironment.PRODUCTION;  // replace with actual value

```


| Please refer our official flutter documentation [here](https://docs.cashfree.com/docs/flutter-integration).


## Getting help

If you have questions, concerns, bug reports, etc, you can reach out to us using one of the following 

1. File an issue in this repository's Issue Tracker.
2. Send a message in our discord channel. Join our [discord server](https://discord.gg/znT6X45qDS) to get connected instantly.
3. Send an email to care@cashfree.com

## Getting involved

For general instructions on _how_ to contribute please refer to [CONTRIBUTING](CONTRIBUTING.md).


----

## Open source licensing and other misc info
1. [LICENSE](https://github.com/cashfree/flutter-cashfree-pg-sdk/blob/master/LICENSE.md)
2. [CODE OF CONDUCT](https://github.com/cashfree/flutter-cashfree-pg-sdk/blob/master/CODE_OF_CONDUCT.md)
